7307e14f5456c61d2fb813a550d58a0a367910e7
[working/Evergreen.git] / Open-ILS / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 # Author: Dan Scott <dscott@laurentian.ca>
4 #
5 # Makefile to install prerequisites for OpenSRF and Evergreen
6 #
7 # Currently supports Debian (squeeze), Ubuntu (lucid), and Fedora (15).
8 # Working towards support of CentOS 5 / RHEL 5.
9 # Installs Perl prereqs, libjs with Perl wrapper, libdbi, libdbi-drivers, and libyaz
10 #
11 # usage:
12 #       make -f Makefile.install debian-squeeze
13 #       - or -
14 #       make -f Makefile.install ubuntu-lucid
15 #       - or -
16 #       make -f Makefile.install fedora15
17 #       - or -
18 #       make -f Makefile.install centos
19 #       - or -
20 #       make -f Makefile.install rhel
21 #
22 # Notes:
23 #
24 #       This makefile has been tested much more with Debian, Ubuntu, and
25 #       Fedora than CentOS, or RHEL.
26 #
27 # ---------------------------------------------------------------------
28  
29 # Make any assumptions about the shell being used explicit
30 SHELL=/bin/bash 
31
32 LIBJS=js-1.7.0
33 LIBJS_PERL=JavaScript-SpiderMonkey-0.20
34 LIBJS_URL=http://ftp.mozilla.org/pub/mozilla.org/js/$(LIBJS).tar.gz
35 LIBJS_PERL_URL=http://mirror.datapipe.net/pub/CPAN/authors/id/T/TB/TBUSCH/$(LIBJS_PERL).tar.gz
36 # used for installing libjs lib and header files
37 JS_INSTALL_PREFIX=/usr/
38
39 # The libdbi sources can be fetched from sourceforge.net.  They are stored on
40 # the open-ils.org site now for ease of direct linking
41 LIBDBI=libdbi-0.8.3
42 LIBDBI_DRIVERS=libdbi-drivers-0.8.3
43 LIBDBI_HOST=http://open-ils.org/~denials/evergreen
44
45 # We need a recent version of Yaz
46 # Debian Lenny and Ubuntu 8.10 come with 3.0.34
47 YAZ=yaz-3.0.47
48 YAZ_HOST=http://ftp.indexdata.dk/pub/yaz
49
50 # Business::OnlinePayment is not packaged on CentOS/RHEL
51 PAY_ONLINE=Business-OnlinePayment-3.00_08.tar.gz
52 PAY_ONLINE_HOST=http://ftp.perl.org/pub/CPAN/authors/id/I/IV/IVAN/
53
54 APT_TOOL=aptitude -yq
55 APT_SAFE_TOOL=aptitude -P
56 APT_BACKPORT_TOOL=aptitude -t squeeze-backports -yq
57
58 # 64 or 32 bit os?
59 LBITS=$(shell getconf LONG_BIT)
60
61 # Fedora?
62 FEDORA=$(shell uname -r | grep "\.fc[0-9][0-9]\.")
63
64 # Fedora 64-bit?
65 FEDORA_64=$(shell uname -r | grep "\.fc[0-9][0-9]\.x86_64")
66
67 #RHEL/Centos PGSQL 
68 PGSQL_HOST=http://yum.pgsqlrpms.org/reporpms/8.4
69 PGSQL_CENTOS=pgdg-centos-8.4-2.noarch.rpm
70 PGSQL_REDHAT=pgdg-redhat-8.4-2.noarch.rpm       
71
72 # Debian dependencies
73 DEBS =  \
74         apache2-prefork-dev\
75         aspell\
76         aspell-en\
77         libbusiness-creditcard-perl\
78         libbusiness-onlinepayment-authorizenet-perl\
79         libbusiness-onlinepayment-perl\
80         libdatetime-format-builder-perl\
81         libdatetime-format-iso8601-perl\
82         libdatetime-format-mail-perl\
83         libdatetime-perl\
84         libdatetime-timezone-perl\
85         libdatetime-set-perl\
86         libdbd-pg-perl\
87         libemail-send-perl\
88         libemail-simple-perl\
89         libgd-graph3d-perl\
90         liblog-log4perl-perl\
91         libmarc-record-perl\
92         libncurses5-dev\
93         libnet-server-perl\
94         libnet-ssh2-perl\
95         libnspr4-dev\
96         libole-storage-lite-perl\
97         libparent-perl \
98         libpq-dev\
99         libreadline5-dev\
100         libspreadsheet-writeexcel-perl\
101         libssh2-1-dev\
102         libtext-aspell-perl\
103         libtext-csv-perl\
104         libuniversal-require-perl\
105         libnet-ip-perl\
106         liblocale-maketext-lexicon-perl\
107         libunix-syslog-perl
108
109 # Debian Lenny and Ubuntu Intrepid bundle recent versions of yaz
110 EXTRA_DEBS = \
111         libbusiness-isbn-perl\
112         libbusiness-isbn-data-perl\
113         libmarc-charset-perl \
114         libmarc-xml-perl \
115         libnet-z3950-zoom-perl \
116         libyaz-dev \
117         yaz
118
119 EXTRA_DEBS_SQUEEZE = \
120     libuuid-tiny-perl
121
122 # Ubuntu Hardy requires libencode-perl # to get a version of Encode
123 # > 2.12 - see bug 525069.
124 EXTRA_ENCODE = \
125         libencode-perl
126
127 CENTOS = \
128         aspell \
129         aspell-devel \
130         aspell-en \
131         gd-devel \
132         libssh2-devel \
133         openssl-devel \
134         perl-Business-CreditCard \
135         perl-Business-ISBN \
136         perl-Business-ISBN-Data \
137         perl-Business-OnlinePayment \
138         perl-Class-Data-Inheritable \
139         perl-DateTime-Format-Builder \
140         perl-DateTime-Format-Strptime \
141         perl-Ima-DBI \
142         perl-DBD-Pg \
143         perl-GD-Graph3d \
144         perl-IO-stringy \
145         perl-Spreadsheet-WriteExcel \
146         perl-Text-Aspell \
147         perl-Text-CSV
148
149 CENTOS_PERL = \
150         Encode \
151         DBIx::ContextualFetch \
152         Getopt::Long \
153         Net::SSH2 \
154         Net::XMPP \
155         Net::Z3950::ZOOM
156
157 FEDORA_RPMS = \
158         aspell \
159         aspell-en \
160         libdbi \
161         libdbi-dbd-pgsql \
162         libdbi-devel \
163         libssh2-devel \
164         libyaz \
165         libyaz-devel \
166         mod_ssl \
167         ncurses-devel \
168         ncurses-libs \
169         perl-parent \
170         perl-Business-CreditCard \
171         perl-Business-ISBN \
172         perl-Business-ISBN-Data \
173         perl-DBD-Pg \
174         perl-Email-Send \
175         perl-Email-Simple \
176         perl-GDGraph3d \
177         perl-Net-IP \
178         perl-Net-SSH2 \
179         perl-OLE-Storage_Lite \
180         perl-Spreadsheet-WriteExcel \
181         perl-Text-Aspell \
182         perl-Text-CSV \
183         perl-Text-CSV_XS \
184         perl-XML-Writer \
185         postgresql-devel \
186         readline-devel \
187         tcp_wrappers-devel \
188         wget \
189         yaz
190
191 # Note: B:O:AuthorizeNet 3.21 fails with https://rt.cpan.org/Public/Bug/Display.html?id=55172
192 # Should be fixed in 3.22
193 # MARC::Record 2.0.1 is required but only 2.0.0 is packaged
194 FEDORA_CPAN = \
195         Business::OnlinePayment \
196         Business::OnlinePayment::AuthorizeNet \
197         MARC::Record \
198         UUID::Tiny
199
200 PGSQL_90_RPMS = \
201         postgresql90 \
202         postgresql90-contrib \
203         postgresql90-devel \
204         postgresql90-libs \
205         postgresql90-plperl \
206         postgresql90-server
207
208 PGSQL_CLIENT_DEBS_90 = \
209         libpq5 \
210         libpq-dev \
211         postgresql-client-9.0
212
213 PGSQL_SERVER_DEBS_90 = \
214         postgresql-9.0 \
215         postgresql-contrib-9.0 \
216         postgresql-plperl-9.0 \
217         postgresql-server-dev-9.0
218
219 DEB_APACHE_MODS = \
220     expires\
221     include\
222     proxy\
223     proxy_http\
224     rewrite
225
226 DEB_APACHE_DISMODS = \
227     deflate
228
229 # Chronically unpackaged CPAN modules
230 CPAN_MODULES = \
231     Business::EDI \
232     Library::CallNumber::LC \
233     Net::Z3950::Simple2ZOOM \
234         Template::Plugin::POSIX \
235     SRU
236
237 # More chronically unpackaged CPAN modules (available in Squeeze though)
238 CPAN_MODULES_MORE = \
239     Business::CreditCard::Object \
240     MARC::Record \
241     Net::SSH2 \
242     UUID::Tiny
243
244 # Are we sure most distros don't come with an acceptable version of Safe.pm?
245 CPAN_MODULES_SAFE = \
246         Safe
247
248 # Recent Debian/Ubuntus have libmarc-charset-perl, libmarc-xml-perl, libnet-z3950-zoom-perl
249 CPAN_MODULES_MARC = \
250         Business::ISBN \
251         Business::ISBN::Data \
252         MARC::Charset \
253         MARC::File::XML \
254         Net::Z3950::ZOOM
255
256 CPAN_MODULES_MARC_RECORD = \
257         MARC::Record
258
259 CPAN_MODULES_FORCE = \
260         Class::DBI::Frozen::301
261
262 # Lucid needs this because the XML::RPC that comes by default is broken with Evergreen
263 LUCID_CPAN = \
264         XML::RPC
265
266 # ----------------------------------------------------------------------------
267
268 all: 
269         @echo "please specify an OS" && exit 0
270
271 # these should be the same for any distro
272 install: install_cpan install_js_sm install_libdbi install_cpan_force
273
274 centos: install_centos_pgsql centos_like
275 rhel: install_redhat_pgsql centos_like
276 centos_like: install_centos_rpms install_yaz install_cpan_marc install install_centos_perl create_ld_local install_cpan_safe install_cpan_force
277
278 fedora15: install_fedora_rpms install_cpan install_cpan_fedora install_cpan_marc install_js_sm install_cpan_force
279
280 debian-squeeze: squeeze generic_debian
281 squeeze: install_pgsql_client_debs_90  install_extra_debs_squeeze
282 generic_debian:  install_debs test_for_libdbi_pkg install debian_sys_config install_cpan_force
283
284 ubuntu-lucid: lucid generic_ubuntu
285 lucid: install_pgsql_client_debs_90 install_extra_debs install_cpan_marc_record install_yaz install_cpan_lucid
286 generic_ubuntu: install_debs test_for_libdbi_pkg install debian_sys_config install_cpan_more install_cpan_safe install_cpan_force
287
288 # - COMMON TARGETS ---------------------------------------------------------
289
290 # Install the CPAN modules
291 install_cpan: 
292         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
293
294 install_cpan_more: 
295         for m in $(CPAN_MODULES_MORE); do perl -MCPAN -e "install \"$$m\";"; done
296
297 # Install the CPAN modules for MARC functionality
298 install_cpan_marc: install_cpan_marc_record
299         for m in $(CPAN_MODULES_MARC); do perl -MCPAN -e "install \"$$m\";"; done
300
301 install_cpan_marc_record:
302         for m in $(CPAN_MODULES_MARC_RECORD); do perl -MCPAN -e "install \"$$m\";"; done
303
304 install_cpan_force:
305         for m in $(CPAN_MODULES_FORCE); do \
306                 echo "force install $$m" | perl -MCPAN -e shell ;\
307         done
308
309 # Install the Safe Perl module
310 # Is this really unpackaged everywhere except for Fedora?
311 install_cpan_safe: 
312         for m in $(CPAN_MODULES_SAFE); do perl -MCPAN -e "install \"$$m\";"; done
313
314 # Install the CPAN modules for Fedora
315 install_cpan_fedora: 
316         for m in $(FEDORA_CPAN); do \
317                 echo "force install $$m" | perl -MCPAN -e shell;\
318         done
319
320 # Install the CPAN modules needed for Lucid
321 install_cpan_lucid:
322         for m in $(LUCID_CPAN); do perl -MCPAN -e "install \"$$m\";"; done
323
324 # Install a known working version of YAZ
325 install_yaz:    
326         if [ ! -d $(YAZ) ]; then wget $(YAZ_HOST)/$(YAZ).tar.gz; fi;
327         tar xzf $(YAZ).tar.gz
328         cd $(YAZ) && ./configure && make && make install && ldconfig
329
330 # Install the custom spidermonkey libs and JavaScript-SpiderMonkey Perl modules
331 install_js_sm: install_libjs install_spidermonkey
332
333 install_libjs: 
334         if [ ! -f $(LIBJS).tar.gz ]; then wget $(LIBJS_URL); fi;
335         tar -zxf $(LIBJS).tar.gz
336         cd js/src/ && JS_DIST=/usr make -f Makefile.ref
337         mkdir -p $(JS_INSTALL_PREFIX)/include/js/
338         cp js/src/*.h $(JS_INSTALL_PREFIX)/include/js/
339         cp js/src/*.tbl $(JS_INSTALL_PREFIX)/include/js/
340         if [ ! -z $(FEDORA_64) ]; then \
341                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib64/ && \
342                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib64/; \
343         else \
344                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib/ && \
345                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib/; \
346         fi;
347         ldconfig
348
349 install_spidermonkey:
350         if [ ! -f $(LIBJS_PERL).tar.gz ]; then wget $(LIBJS_PERL_URL); fi;
351         tar -zxf $(LIBJS_PERL).tar.gz
352         if [ ! -z $(FEDORA_64) ]; then \
353                 sed -i -e 's/"\/usr\/lib"/"\/usr\/lib64"/' $(LIBJS_PERL)/Makefile.PL ; \
354         fi;
355         if [ ! -z $(FEDORA) ]; then \
356                 sed -i -e 's/js32.dll/libjs.so/' $(LIBJS_PERL)/Makefile.PL ; \
357         fi;
358         cd $(LIBJS_PERL) && perl Makefile.PL -E4X && make && make test && make install
359
360 # On Ubuntu and possibly Debian, the libdbi0 package prevents the 
361 # compiled-from-source version from being used and breaks the install.
362 # This package might get installed depending on the install-time choices
363 # for the distro. Test for its existence; if it's there, throw an error
364 # message and exit.
365 test_for_libdbi_pkg:
366                 @if [ "$$(apt-cache policy libdbi0 | grep Installed | grep none | wc -l)" -eq 0 ]; then \
367                                 echo "*** Detected locally installed libdbi0 package; you must remove this"; \
368                                 echo "*** with a command like 'aptitude remove libdbi0' before proceeding"; \
369                                 echo "*** to successfully install Evergreen."; \
370                                 echo; \
371                                 echo "*** Note: this may break other applications on your system."; \
372                                 exit 0; \
373                 fi;
374
375 # Install libdbi and the postgres drivers
376 install_libdbi:
377         if [ ! -d $(LIBDBI) ]; then wget $(LIBDBI_HOST)/$(LIBDBI).tar.gz; fi;
378         if [ ! -d $(LIBDBI_DRIVERS) ]; then wget $(LIBDBI_HOST)/$(LIBDBI_DRIVERS).tar.gz; fi;
379         tar -zxf $(LIBDBI).tar.gz
380         tar -zxf $(LIBDBI_DRIVERS).tar.gz
381         cd $(LIBDBI) && ./configure --disable-docs && make all install
382         cd $(LIBDBI_DRIVERS) && ./configure  \
383                 --disable-docs --with-pgsql --enable-libdbi && make all install  
384
385 clean:
386         make -C $(LIBDBI) clean
387         make -C $(LIBDBI_DRIVERS) clean
388         make -C $(LIBJS_PERL) clean
389         make -f Makefile.ref -C js/src/ clean
390
391
392 # ------------------------------------------------------------------
393 # - DEBIAN ---------------------------------------------------------
394
395 debian_sys_config: 
396         # link the apache modules in
397         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
398         # keep the bad apache modules away
399         for m in $(DEB_APACHE_DISMODS); do a2dismod $$m; done;
400         # refresh the dynamic library cache
401         ldconfig
402
403 # Install the debian-specific dependencies
404 install_debs:
405         $(APT_TOOL) install $(DEBS)
406
407 install_pgsql_client_debs_90:
408         @if [ `$(APT_TOOL) versions libpq-dev | grep ^i|sed 's/^i[ \t]*//'|cut -d. -f1` -eq 8 ]; \
409                 then \
410                 echo -e "libpq5 / libpq-dev are installed as part of OpenSRF (a dependency" \
411                 "of apache2-prefork-dev), but these are the 8.4 versions and they" \
412                 "conflict with the 9.0 versions - so remove them, install the pinned" \
413                 "backports of 9.0, then reinstall the apache2-prefork-dev package.\n\n" \
414                 "**WARNING**: Saying 'Yes' to this step will _remove_ any PostgreSQL" \
415                 "databases that might currently exist on this machine." && \
416                 $(APT_SAFE_TOOL) remove libpq5 libpq-dev ; \
417         fi
418         $(APT_BACKPORT_TOOL) install $(PGSQL_CLIENT_DEBS_90)
419         $(APT_TOOL) install apache2-prefork-dev
420
421 install_pgsql_server_debs_90:
422         $(APT_BACKPORT_TOOL) install $(PGSQL_SERVER_DEBS_90)
423
424 # Install the debian-specific dependencies for more modern distros
425 install_extra_debs_squeeze: install_extra_debs
426         $(APT_TOOL) install $(EXTRA_DEBS_SQUEEZE)
427
428 install_extra_debs:
429         $(APT_TOOL) install $(EXTRA_DEBS)
430
431 # Install specific modules required by Ubuntu Hardy - see bug 525069
432 install_extra_encode:
433         $(APT_TOOL) install $(EXTRA_ENCODE)
434
435 # ------------------------------------------------------------------
436
437 # FEDORA
438 install_fedora_rpms:
439         yum -y update
440         yum -y install $(FEDORA_RPMS)
441
442 install_fedora_pgsql_server:
443         yum -y install $(PGSQL_84_RPMS)
444
445 # CENTOS
446 install_centos_rpms:
447         yum -y install $(CENTOS)
448         yum -y update
449         if [ $(LBITS) -eq 64 ]; then \
450                 ln -sf /usr/lib64/libpq.* /usr/lib/ && \
451                 ln -sf /usr/lib64/perl5/5.8.8/x86_64-linux-thread-multi/CORE/libperl.so /usr/lib/ && \
452                 ldconfig ; \
453         fi;
454         if [ $(LBITS) -eq 32 ]; then \
455                 ln -sf /usr/lib/perl5/5.8.8/i386-linux-thread-multi/CORE/libperl.so /usr/lib && \
456                 ldconfig ; \
457         fi;
458
459 install_centos_pgsql:
460         if [ $(LBITS) -eq 64 ]; then yum remove -y postgresql-libs-8.1*i386 apr-util-devel-*i386 ; fi;
461         wget $(PGSQL_HOST)/$(PGSQL_CENTOS)
462         rpm -Uvh --force ./$(PGSQL_CENTOS)
463         yum update -y
464         yum -y install $(PGSQL_84_RPMS)
465
466 install_redhat_pgsql:
467         if [ $(LBITS) -eq 64 ]; then yum remove -y postgresql-libs-8.1*i386 apr-util-devel-*i386 ; fi;
468         wget $(PGSQL_HOST)/$(PGSQL_REDHAT)
469         rpm -Uvh --force ./$(PGSQL_REDHAT)
470         yum update -y
471         yum -y install $(PGSQL_84_RPMS)
472
473 install_centos_perl:
474         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
475         echo "force install Business::OnlinePayment::AuthorizeNet" | perl -MCPAN -e shell
476         echo "force install Scalar::Util" | perl -MCPAN -e shell        
477
478 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
479 # if it is not already there
480 create_ld_local:
481         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
482                 echo '/usr/local/lib' >> /etc/ld.so.conf.d/local.conf; \
483                 ldconfig; \
484         fi;
485
486 # vim:noet:sw=4:ts=4: